Package org.codehaus.groovy.runtime

# Class CurriedClosure<V>

java.lang.Object
groovy.lang.GroovyObjectSupport
groovy.lang.Closure<V>
org.codehaus.groovy.runtime.CurriedClosure<V>

All Implemented Interfaces:
  `GroovyCallable<V>`, `GroovyObject`, `Serializable`, `Cloneable`, `Runnable`, `Callable<V>`

public final class CurriedClosure<V> extends Closure<V>
A wrapper for Closure to support currying. Normally used only internally through the `curry()`, `rcurry()` or `ncurry()` methods on `Closure`. Typical usages:

     // normal usage
     def unitAdder = { first, second, unit -> "${first + second} $unit" }
     assert unitAdder(10, 15, "minutes") == "25 minutes"
     assert unitAdder.curry(60)(15, "minutes") == "75 minutes"
     def minuteAdder = unitAdder.rcurry("minutes")
     assert minuteAdder(15, 60) == "75 minutes"

     // explicit creation
     import org.codehaus.groovy.runtime.CurriedClosure
     assert new CurriedClosure(unitAdder, 45)(15, "minutes") == "60 minutes"
     assert new CurriedClosure(unitAdder, "six", "ty")("minutes") == "sixty minutes"

Notes:

- Caters for Groovy's lazy (rcurry) and eager (ncurry) calculation of argument position

See Also:
  - Serialized Form

## Field Summary

### Fields inherited from class groovy.lang.Closure

`DELEGATE_FIRST, DELEGATE_ONLY, DONE, IDENTITY, maximumNumberOfParameters, OWNER_FIRST, OWNER_ONLY, parameterTypes, SKIP, TO_SELF`

## Constructor Summary

Constructors
Constructor
Description
`CurriedClosure(int index, Closure<V> uncurriedClosure, Object... arguments)`
Creates the curried closure.
`CurriedClosure(Closure<V> uncurriedClosure, Object... arguments)`

## Method Summary

Modifier and Type
Method
Description
`Object`
`clone()`
`Object`
`getDelegate()`
`Class[]`
`getParameterTypes()`
`int`
`getResolveStrategy()`
Gets the strategy which the closure uses to resolve methods and properties
`Object[]`
`getUncurriedArguments(Object... arguments)`
`void`
`setDelegate(Object delegate)`
Allows the delegate to be changed such as when performing markup building
`void`
`setResolveStrategy(int resolveStrategy)`
Sets the strategy which the closure uses to resolve property references and methods.

### Methods inherited from class groovy.lang.Closure

`asWritable, call, call, call, curry, curry, dehydrate, getDirective, getMaximumNumberOfParameters, getOwner, getProperty, getThisObject, isCase, leftShift, leftShift, memoize, memoizeAtLeast, memoizeAtMost, memoizeBetween, ncurry, ncurry, rcurry, rcurry, rehydrate, rightShift, run, setDirective, setProperty, throwRuntimeException, trampoline, trampoline`

### Methods inherited from class groovy.lang.GroovyObjectSupport

`getMetaClass, invokeMethod, setMetaClass`

### Methods inherited from class java.lang.Object

`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### CurriedClosure

public CurriedClosure(int index, Closure<V> uncurriedClosure, Object... arguments)
Creates the curried closure.

Parameters:
  `index` - the position where the parameters should be injected (-ve for lazy)
  `uncurriedClosure` - the closure to be called after the curried parameters are injected
  `arguments` - the supplied parameters

### CurriedClosure

public CurriedClosure(Closure<V> uncurriedClosure, Object... arguments)

## Method Details

### getUncurriedArguments

public Object[] getUncurriedArguments(Object... arguments)

### setDelegate

public void setDelegate(Object delegate)
Description copied from class: `Closure`
Allows the delegate to be changed such as when performing markup building

Overrides:
  `setDelegate` in class `Closure<V>`
Parameters:
  `delegate` - the new delegate

### getDelegate

public Object getDelegate()

Overrides:
  `getDelegate` in class `Closure<V>`
Returns:
  the delegate Object to which method calls will go which is typically the outer class when the closure is constructed

### setResolveStrategy

public void setResolveStrategy(int resolveStrategy)
Description copied from class: `Closure`
Sets the strategy which the closure uses to resolve property references and methods. The default is Closure.OWNER_FIRST

Overrides:
  `setResolveStrategy` in class `Closure<V>`
Parameters:
  `resolveStrategy` - The resolve strategy to set
See Also:
  - `Closure.DELEGATE_FIRST`
  - `Closure.DELEGATE_ONLY`
  - `Closure.OWNER_FIRST`
  - `Closure.OWNER_ONLY`
  - `Closure.TO_SELF`

### getResolveStrategy

public int getResolveStrategy()
Description copied from class: `Closure`
Gets the strategy which the closure uses to resolve methods and properties

Overrides:
  `getResolveStrategy` in class `Closure<V>`
Returns:
  The resolve strategy
See Also:
  - `Closure.DELEGATE_FIRST`
  - `Closure.DELEGATE_ONLY`
  - `Closure.OWNER_FIRST`
  - `Closure.OWNER_ONLY`
  - `Closure.TO_SELF`

### clone

public Object clone()

Overrides:
  `clone` in class `Closure<V>`

### getParameterTypes

public Class[] getParameterTypes()

Overrides:
  `getParameterTypes` in class `Closure<V>`
Returns:
  the parameter types of the longest doCall method of this closure